Loading...
Searching...
No Matches
itk::ComputeDisplacementDistribution< TFixedImage, TTransform > Class Template Reference

`#include <itkComputeDisplacementDistribution.h>`

## Detailed Description

template<class TFixedImage, class TTransform>
class itk::ComputeDisplacementDistribution< TFixedImage, TTransform >

This is a helper class for the automatic parameter estimation of the ASGD optimizer.

More specifically this class computes the Jacobian terms related to the automatic parameter estimation for the adaptive stochastic gradient descent optimizer. Details can be found in the TMI paper

[1] Y. Qiao, B. van Lew, B.P.F. Lelieveldt and M. Staring "Fast Automatic Step Size Estimation for Gradient Descent Optimization of Image Registration," IEEE Transactions on Medical Imaging, vol. 35, no. 2, pp. 391 - 403, February 2016. http://elastix.dev/marius/publications/2016_j_TMIa.php

Definition at line 48 of file itkComputeDisplacementDistribution.h.

Inheritance diagram for itk::ComputeDisplacementDistribution< TFixedImage, TTransform >:
[legend]

## Data Structures

struct | ComputePerThreadStruct
struct | MultiThreaderParameterType

## Public Types

using | ConstPointer = SmartPointer<const Self>
using | FixedImageMaskConstPointer = typename FixedImageMaskType::ConstPointer
using | FixedImageMaskPointer = typename FixedImageMaskType::Pointer
using | FixedImageMaskType = ImageMaskSpatialObject<Self::FixedImageDimension>
using | FixedImagePixelType = typename FixedImageType::PixelType
using | FixedImageRegionType = typename FixedImageType::RegionType
using | FixedImageType = TFixedImage
using | NonZeroJacobianIndicesType = typename TransformType::NonZeroJacobianIndicesType
using | Pointer = SmartPointer<Self>
using | ScalesType
using | Self = ComputeDisplacementDistribution
using | Superclass = ScaledSingleValuedNonLinearOptimizer
using | TransformPointer = typename TransformType::Pointer
using | TransformType = TTransform
Public Types inherited from itk::ScaledSingleValuedNonLinearOptimizer
using | ConstPointer = SmartPointer<const Self>
using | Pointer = SmartPointer<Self>
using | ScaledCostFunctionPointer = ScaledCostFunctionType::Pointer
using | ScaledCostFunctionType = ScaledSingleValuedCostFunction
using | ScalesType = NonLinearOptimizer::ScalesType
using | Self = ScaledSingleValuedNonLinearOptimizer
using | Superclass = SingleValuedNonLinearOptimizer

## Public Member Functions

virtual void | AfterThreadedCompute (double &jacg, double &maxJJ)
virtual void | BeforeThreadedCompute (const ParametersType &mu)
virtual void | Compute (const ParametersType &mu, double &jacg, double &maxJJ, std::string method)
virtual void | ComputeSingleThreaded (const ParametersType &mu, double &jacg, double &maxJJ, std::string method)
virtual void | ComputeUsingSearchDirection (const ParametersType &mu, double &jacg, double &maxJJ, std::string methods)
virtual const char * | GetClassName () const
virtual const FixedImageMaskType * | GetFixedImageMask ()
virtual const FixedImageRegionType & | GetFixedImageRegion ()
| ITK_DISALLOW_COPY_AND_MOVE (ComputeDisplacementDistribution)
| itkStaticConstMacro (FixedImageDimension, unsigned int, TFixedImage::ImageDimension)
virtual void | SetFixedImage (const FixedImageType *_arg)
virtual void | SetFixedImageMask (const FixedImageMaskType *_arg)
virtual void | SetFixedImageMask (FixedImageMaskType *_arg)
void | SetFixedImageRegion (const FixedImageRegionType &region)
virtual void | SetNumberOfJacobianMeasurements (SizeValueType _arg)
void | SetNumberOfWorkUnits (ThreadIdType numberOfThreads)
virtual void | SetTransform (TransformType *_arg)
Public Member Functions inherited from itk::ScaledSingleValuedNonLinearOptimizer
const ParametersType & | GetCurrentPosition () const override
virtual bool | GetMaximize () const
virtual const ScaledCostFunctionType * | GetScaledCostFunction ()
virtual const ParametersType & | GetScaledCurrentPosition ()
bool | GetUseScales () const
virtual void | InitializeScales ()
| ITK_DISALLOW_COPY_AND_MOVE (ScaledSingleValuedNonLinearOptimizer)
virtual void | MaximizeOff ()
virtual void | MaximizeOn ()
void | SetCostFunction (CostFunctionType *costFunction) override
virtual void | SetMaximize (bool _arg)
virtual void | SetUseScales (bool arg)

## Static Public Member Functions

static Pointer | New ()
Static Public Member Functions inherited from itk::ScaledSingleValuedNonLinearOptimizer
static Pointer | New ()

## Protected Types

using | CoordinateRepresentationType = typename TransformType::ScalarType
using | FixedImageIndexType = typename FixedImageType::IndexType
using | FixedImagePointType = typename FixedImageType::PointType
using | ImageFullSamplerPointer = typename ImageFullSamplerType::Pointer
using | ImageFullSamplerType = ImageFullSampler<FixedImageType>
using | ImageGridSamplerPointer = typename ImageGridSamplerType::Pointer
using | ImageGridSamplerType = ImageGridSampler<FixedImageType>
using | ImageRandomSamplerBasePointer = typename ImageRandomSamplerBaseType::Pointer
using | ImageRandomSamplerBaseType = ImageRandomSamplerBase<FixedImageType>
using | ImageSampleContainerPointer = typename ImageSampleContainerType::Pointer
using | ImageSampleContainerType = typename ImageGridSamplerType ::ImageSampleContainerType
using | ImageSamplerBasePointer = typename ImageSamplerBaseType::Pointer
using | ImageSamplerBaseType = ImageSamplerBase<FixedImageType>
using | JacobianType = typename TransformType::JacobianType
using | JacobianValueType = typename JacobianType::ValueType
using | NumberOfParametersType = typename TransformType::NumberOfParametersType
using | ThreadInfoType = MultiThreaderBase::WorkUnitInfo
using | TransformJacobianType = JacobianType

## Protected Member Functions

| ComputeDisplacementDistribution ()
virtual void | InitializeThreadingParameters ()
| itkAlignedTypedef (ITK_CACHE_LINE_ALIGNMENT, PaddedComputePerThreadStruct, AlignedComputePerThreadStruct)
| itkPadStruct (ITK_CACHE_LINE_ALIGNMENT, ComputePerThreadStruct, PaddedComputePerThreadStruct)
void | LaunchComputeThreaderCallback () const
virtual void | SampleFixedImageForJacobianTerms (ImageSampleContainerPointer &sampleContainer)
virtual void | ThreadedCompute (ThreadIdType threadID)
| ~ComputeDisplacementDistribution () override=default
Protected Member Functions inherited from itk::ScaledSingleValuedNonLinearOptimizer
virtual void | GetScaledDerivative (const ParametersType &parameters, DerivativeType &derivative) const
virtual MeasureType | GetScaledValue (const ParametersType &parameters) const
virtual void | GetScaledValueAndDerivative (const ParametersType &parameters, MeasureType &value, DerivativeType &derivative) const
void | PrintSelf (std::ostream &os, Indent indent) const override
| ScaledSingleValuedNonLinearOptimizer ()
void | SetCurrentPosition (const ParametersType &param) override
virtual void | SetScaledCurrentPosition (const ParametersType &parameters)
| ~ScaledSingleValuedNonLinearOptimizer () override=default

## Static Protected Member Functions

static ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION | ComputeThreaderCallback (void *arg)

## Protected Attributes

ScaledSingleValuedCostFunction::Pointer | m_CostFunction {}
DerivativeType | m_ExactGradient {}
FixedImageType::ConstPointer | m_FixedImage {}
FixedImageMaskConstPointer | m_FixedImageMask {}
FixedImageRegionType | m_FixedImageRegion {}
SizeValueType | m_NumberOfJacobianMeasurements {}
SizeValueType | m_NumberOfParameters {}
MultiThreaderBase::Pointer | m_Threader {}
TransformPointer | m_Transform {}
Protected Attributes inherited from itk::ScaledSingleValuedNonLinearOptimizer
ScaledCostFunctionPointer | m_ScaledCostFunction {}
ParametersType | m_ScaledCurrentPosition {}

## Private Attributes

std::vector< AlignedComputePerThreadStruct > | m_ComputePerThreadVariables {}
SizeValueType | m_NumberOfPixelsCounted {}
ImageSampleContainerPointer | m_SampleContainer {}
MultiThreaderParameterType | m_ThreaderParameters {}
bool | m_UseMultiThread {}

## Member Typedef Documentation

## ConstPointer

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ConstPointer = SmartPointer<const Self>

Definition at line 57 of file itkComputeDisplacementDistribution.h.

## CoordinateRepresentationType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::CoordinateRepresentationType = typename TransformType::ScalarType

protected

Definition at line 176 of file itkComputeDisplacementDistribution.h.

## FixedImageIndexType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::FixedImageIndexType = typename FixedImageType::IndexType

protected

Definition at line 154 of file itkComputeDisplacementDistribution.h.

## FixedImageMaskConstPointer

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::FixedImageMaskConstPointer = typename FixedImageMaskType::ConstPointer

Definition at line 81 of file itkComputeDisplacementDistribution.h.

## FixedImageMaskPointer

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::FixedImageMaskPointer = typename FixedImageMaskType::Pointer

Definition at line 80 of file itkComputeDisplacementDistribution.h.

## FixedImageMaskType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::FixedImageMaskType = ImageMaskSpatialObject<Self::FixedImageDimension>

Definition at line 79 of file itkComputeDisplacementDistribution.h.

## FixedImagePixelType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::FixedImagePixelType = typename FixedImageType::PixelType

Definition at line 67 of file itkComputeDisplacementDistribution.h.

## FixedImagePointType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::FixedImagePointType = typename FixedImageType::PointType

protected

Definition at line 155 of file itkComputeDisplacementDistribution.h.

## FixedImageRegionType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::FixedImageRegionType = typename FixedImageType::RegionType

Definition at line 70 of file itkComputeDisplacementDistribution.h.

## FixedImageType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::FixedImageType = TFixedImage

typedef

Definition at line 66 of file itkComputeDisplacementDistribution.h.

## ImageFullSamplerPointer

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ImageFullSamplerPointer = typename ImageFullSamplerType::Pointer

protected

Definition at line 164 of file itkComputeDisplacementDistribution.h.

## ImageFullSamplerType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ImageFullSamplerType = ImageFullSampler<FixedImageType>

protected

Definition at line 163 of file itkComputeDisplacementDistribution.h.

## ImageGridSamplerPointer

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ImageGridSamplerPointer = typename ImageGridSamplerType::Pointer

protected

Definition at line 170 of file itkComputeDisplacementDistribution.h.

## ImageGridSamplerType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ImageGridSamplerType = ImageGridSampler<FixedImageType>

protected

Definition at line 169 of file itkComputeDisplacementDistribution.h.

## ImageRandomSamplerBasePointer

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ImageRandomSamplerBasePointer = typename ImageRandomSamplerBaseType::Pointer

protected

Definition at line 167 of file itkComputeDisplacementDistribution.h.

## ImageRandomSamplerBaseType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ImageRandomSamplerBaseType = ImageRandomSamplerBase<FixedImageType>

protected

Definition at line 166 of file itkComputeDisplacementDistribution.h.

## ImageSampleContainerPointer

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ImageSampleContainerPointer = typename ImageSampleContainerType::Pointer

protected

Definition at line 172 of file itkComputeDisplacementDistribution.h.

## ImageSampleContainerType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ImageSampleContainerType = typename ImageGridSamplerType ::ImageSampleContainerType

protected

Definition at line 171 of file itkComputeDisplacementDistribution.h.

## ImageSamplerBasePointer

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ImageSamplerBasePointer = typename ImageSamplerBaseType::Pointer

protected

Definition at line 161 of file itkComputeDisplacementDistribution.h.

## ImageSamplerBaseType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ImageSamplerBaseType = ImageSamplerBase<FixedImageType>

protected

Samplers.

Definition at line 160 of file itkComputeDisplacementDistribution.h.

## JacobianType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::JacobianType = typename TransformType::JacobianType

protected

Definition at line 156 of file itkComputeDisplacementDistribution.h.

## JacobianValueType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::JacobianValueType = typename JacobianType::ValueType

protected

Definition at line 157 of file itkComputeDisplacementDistribution.h.

## NonZeroJacobianIndicesType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::NonZeroJacobianIndicesType = typename TransformType::NonZeroJacobianIndicesType

Definition at line 82 of file itkComputeDisplacementDistribution.h.

## NumberOfParametersType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::NumberOfParametersType = typename TransformType::NumberOfParametersType

protected

Definition at line 177 of file itkComputeDisplacementDistribution.h.

## Pointer

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::Pointer = SmartPointer<Self>

Definition at line 56 of file itkComputeDisplacementDistribution.h.

## ScalesType

template<class TFixedImage, class TTransform>

using itk::ScaledSingleValuedNonLinearOptimizer::ScalesType

Definition at line 85 of file itkScaledSingleValuedNonLinearOptimizer.h.

## Self

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::Self = ComputeDisplacementDistribution

Standard ITK.

Definition at line 54 of file itkComputeDisplacementDistribution.h.

## Superclass

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::Superclass = ScaledSingleValuedNonLinearOptimizer

Definition at line 55 of file itkComputeDisplacementDistribution.h.

## ThreadInfoType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ThreadInfoType = MultiThreaderBase::WorkUnitInfo

protected

Typedef for multi-threading.

Definition at line 142 of file itkComputeDisplacementDistribution.h.

## TransformJacobianType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::TransformJacobianType = JacobianType

protected

Typedefs for support of sparse Jacobians and AdvancedTransforms.

Definition at line 175 of file itkComputeDisplacementDistribution.h.

## TransformPointer

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::TransformPointer = typename TransformType::Pointer

Definition at line 69 of file itkComputeDisplacementDistribution.h.

## TransformType

template<class TFixedImage, class TTransform>

using itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::TransformType = TTransform

Definition at line 68 of file itkComputeDisplacementDistribution.h.

## Constructor & Destructor Documentation

## ComputeDisplacementDistribution()

template<class TFixedImage, class TTransform>

itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ComputeDisplacementDistribution | ( |  | ) |

protected

## ~ComputeDisplacementDistribution()

template<class TFixedImage, class TTransform>

itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::~ComputeDisplacementDistribution | ( |  | ) |

override protected default

## Member Function Documentation

## AfterThreadedCompute()

template<class TFixedImage, class TTransform>

virtual void itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::AfterThreadedCompute | ( | double & | jacg,
|  | double & | maxJJ )

virtual

## BeforeThreadedCompute()

template<class TFixedImage, class TTransform>

virtual void itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::BeforeThreadedCompute | ( | const ParametersType & | mu | ) |

virtual

## Compute()

template<class TFixedImage, class TTransform>

virtual void itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::Compute | ( | const ParametersType & | mu,
|  | double & | jacg,
|  | double & | maxJJ,
|  | std::string | method )

virtual

The main function that performs the multi-threaded computation.

Reimplemented in itk::ComputePreconditionerUsingDisplacementDistribution< TFixedImage, TTransform >, and itk::ComputePreconditionerUsingDisplacementDistribution< FixedImageType, TransformType >.

## ComputeSingleThreaded()

template<class TFixedImage, class TTransform>

virtual void itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ComputeSingleThreaded | ( | const ParametersType & | mu,
|  | double & | jacg,
|  | double & | maxJJ,
|  | std::string | method )

virtual

The main function that performs the single-threaded computation.

## ComputeThreaderCallback()

template<class TFixedImage, class TTransform>

ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ComputeThreaderCallback | ( | void * | arg | ) |

static protected

Compute threader callback function.

## ComputeUsingSearchDirection()

template<class TFixedImage, class TTransform>

virtual void itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ComputeUsingSearchDirection | ( | const ParametersType & | mu,
|  | double & | jacg,
|  | double & | maxJJ,
|  | std::string | methods )

virtual

## GetClassName()

template<class TFixedImage, class TTransform>

virtual const char * itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from itk::ScaledSingleValuedNonLinearOptimizer.

Reimplemented in itk::ComputePreconditionerUsingDisplacementDistribution< TFixedImage, TTransform >, and itk::ComputePreconditionerUsingDisplacementDistribution< FixedImageType, TransformType >.

## GetFixedImageMask()

template<class TFixedImage, class TTransform>

virtual const FixedImageMaskType * itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::GetFixedImageMask | ( |  | ) |

virtual

## GetFixedImageRegion()

template<class TFixedImage, class TTransform>

virtual const FixedImageRegionType & itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::GetFixedImageRegion | ( |  | ) |

virtual

Get the region over which the metric will be computed.

## InitializeThreadingParameters()

template<class TFixedImage, class TTransform>

virtual void itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::InitializeThreadingParameters | ( |  | ) |

protected virtual

Initialize some multi-threading related parameters.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TFixedImage, class TTransform>

itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ITK_DISALLOW_COPY_AND_MOVE | ( | ComputeDisplacementDistribution< TFixedImage, TTransform > |  | ) |

## itkAlignedTypedef()

template<class TFixedImage, class TTransform>

itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::itkAlignedTypedef | ( | ITK_CACHE_LINE_ALIGNMENT | ,
|  | PaddedComputePerThreadStruct | ,
|  | AlignedComputePerThreadStruct | )

protected

## itkPadStruct()

template<class TFixedImage, class TTransform>

itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::itkPadStruct | ( | ITK_CACHE_LINE_ALIGNMENT | ,
|  | ComputePerThreadStruct | ,
|  | PaddedComputePerThreadStruct | )

protected

## itkStaticConstMacro()

template<class TFixedImage, class TTransform>

itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::itkStaticConstMacro | ( | FixedImageDimension | ,
|  | unsigned int | ,
|  | TFixedImage::ImageDimension | )

Type for the mask of the fixed image. Only pixels that are "inside" this mask will be considered for the computation of the Jacobian terms.

## LaunchComputeThreaderCallback()

template<class TFixedImage, class TTransform>

void itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::LaunchComputeThreaderCallback | ( |  | ) | const

protected

Launch MultiThread Compute.

## New()

template<class TFixedImage, class TTransform>

Pointer itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::New | ( |  | ) |

static

Method for creation through the object factory.

## SampleFixedImageForJacobianTerms()

template<class TFixedImage, class TTransform>

virtual void itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::SampleFixedImageForJacobianTerms | ( | ImageSampleContainerPointer & | sampleContainer | ) |

protected virtual

Sample the fixed image to compute the Jacobian terms.

## SetFixedImage()

template<class TFixedImage, class TTransform>

virtual void itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::SetFixedImage | ( | const FixedImageType * | _arg | ) |

virtual

Set the fixed image.

## SetFixedImageMask() [1/2]

template<class TFixedImage, class TTransform>

virtual void itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::SetFixedImageMask | ( | const FixedImageMaskType * | _arg | ) |

virtual

## SetFixedImageMask() [2/2]

template<class TFixedImage, class TTransform>

virtual void itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::SetFixedImageMask | ( | FixedImageMaskType * | _arg | ) |

virtual

Set/Get the fixed image mask.

## SetFixedImageRegion()

template<class TFixedImage, class TTransform>

void itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::SetFixedImageRegion | ( | const FixedImageRegionType & | region | ) |

inline

Set the region over which the metric will be computed.

Definition at line 100 of file itkComputeDisplacementDistribution.h.

## SetNumberOfJacobianMeasurements()

template<class TFixedImage, class TTransform>

virtual void itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::SetNumberOfJacobianMeasurements | ( | SizeValueType | _arg | ) |

virtual

Set some parameters.

## SetNumberOfWorkUnits()

template<class TFixedImage, class TTransform>

void itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::SetNumberOfWorkUnits | ( | ThreadIdType | numberOfThreads | ) |

inline

Set the number of threads.

Definition at line 125 of file itkComputeDisplacementDistribution.h.

## SetTransform()

template<class TFixedImage, class TTransform>

virtual void itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::SetTransform | ( | TransformType * | _arg | ) |

virtual

Set the transform.

## ThreadedCompute()

template<class TFixedImage, class TTransform>

virtual void itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::ThreadedCompute | ( | ThreadIdType | threadID | ) |

protected virtual

The threaded implementation of Compute().

## Field Documentation

## m_ComputePerThreadVariables

template<class TFixedImage, class TTransform>

std::vector<AlignedComputePerThreadStruct> itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::m_ComputePerThreadVariables {}

mutable private

Definition at line 220 of file itkComputeDisplacementDistribution.h.

## m_CostFunction

template<class TFixedImage, class TTransform>

ScaledSingleValuedCostFunction::Pointer itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::m_CostFunction {}

protected

Definition at line 148 of file itkComputeDisplacementDistribution.h.

## m_ExactGradient

template<class TFixedImage, class TTransform>

DerivativeType itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::m_ExactGradient {}

protected

Definition at line 150 of file itkComputeDisplacementDistribution.h.

## m_FixedImage

template<class TFixedImage, class TTransform>

FixedImageType::ConstPointer itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::m_FixedImage {}

protected

Definition at line 144 of file itkComputeDisplacementDistribution.h.

## m_FixedImageMask

template<class TFixedImage, class TTransform>

FixedImageMaskConstPointer itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::m_FixedImageMask {}

protected

Definition at line 146 of file itkComputeDisplacementDistribution.h.

## m_FixedImageRegion

template<class TFixedImage, class TTransform>

FixedImageRegionType itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::m_FixedImageRegion {}

protected

Definition at line 145 of file itkComputeDisplacementDistribution.h.

## m_NumberOfJacobianMeasurements

template<class TFixedImage, class TTransform>

SizeValueType itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::m_NumberOfJacobianMeasurements {}

protected

Definition at line 149 of file itkComputeDisplacementDistribution.h.

## m_NumberOfParameters

template<class TFixedImage, class TTransform>

SizeValueType itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::m_NumberOfParameters {}

protected

Definition at line 151 of file itkComputeDisplacementDistribution.h.

## m_NumberOfPixelsCounted

template<class TFixedImage, class TTransform>

SizeValueType itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::m_NumberOfPixelsCounted {}

private

Definition at line 222 of file itkComputeDisplacementDistribution.h.

## m_SampleContainer

template<class TFixedImage, class TTransform>

ImageSampleContainerPointer itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::m_SampleContainer {}

private

Definition at line 224 of file itkComputeDisplacementDistribution.h.

## m_Threader

template<class TFixedImage, class TTransform>

MultiThreaderBase::Pointer itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::m_Threader {}

protected

Definition at line 152 of file itkComputeDisplacementDistribution.h.

## m_ThreaderParameters

template<class TFixedImage, class TTransform>

MultiThreaderParameterType itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::m_ThreaderParameters {}

mutable private

Definition at line 218 of file itkComputeDisplacementDistribution.h.

## m_Transform

template<class TFixedImage, class TTransform>

TransformPointer itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::m_Transform {}

protected

Definition at line 147 of file itkComputeDisplacementDistribution.h.

## m_UseMultiThread

template<class TFixedImage, class TTransform>

bool itk::ComputeDisplacementDistribution< TFixedImage, TTransform >::m_UseMultiThread {}

private

Definition at line 223 of file itkComputeDisplacementDistribution.h.

Generated on 1768596610 for elastix by 1.15.0 |